(* Listsort *)

(** Smooth Applicative Merge Sort, Richard O'Keefe 1982        **)
(** From L.C. Paulson: ML for the Working Programmer, CUP 1991 **)

exception ListSortImpossible

fun sort ordr xs =
    let fun merge []      ys = ys 
          | merge xs      [] = xs
          | merge (x::xs) (y::ys) =
            if ordr(x, y) <> GREATER then x :: merge xs (y::ys)
            else y :: merge (x::xs) ys
        fun mergepairs [l]          k = [l]
          | mergepairs (l1::l2::ls) k =
            if k mod 2 = 1 then l1::l2::ls
            else mergepairs (merge l1 l2 :: ls) (k div 2)
	  | mergepairs _ _ = raise ListSortImpossible
        fun sorting []      ls r = List.hd(mergepairs ls 0)
          | sorting (x::xs) ls r =
            sorting xs (mergepairs ([x]::ls) (r+1)) (r+1)
    in sorting xs [[]] 0 end;

fun sorted ordr []         = true
  | sorted ordr (y1 :: yr) = 
    let fun h x0 []       = true
	  | h x0 (x1::xr) = ordr(x0, x1) <> GREATER andalso h x1 xr
    in h y1 yr end;
