(* Math.sml, 1995-02-21 *)

type real = real

exception Sqrt = Sqrt
      and Ln   = Ln
      and Trig = Trig;

val pi = 3.14159265358979323846;
val e  = 2.7182818284590452354;

val sqrt = sqrt;
val sin  = sin
val cos  = cos
fun tan r = (sin r / cos r) handle _ => raise Trig;
val atan = arctan;

prim_val asin   : real -> real         = 1 "sml_asin";
prim_val acos   : real -> real         = 1 "sml_acos";

local 
    prim_val atan2_ : real -> real -> real = 2 "sml_atan2";
    prim_val pow_   : real -> real -> real = 2 "sml_pow";
in
    fun atan2(x, y) = atan2_ x y;
    fun pow (x, y) = pow_ x y;
end

val exp = exp;
val ln = ln;
fun log10 r = ln r / ln 10.0;
