(* Misc 1995-09-12 *)

(* These functions really belong in General, but can appear there only 
   if defined in the runtime system.  So for now they are here.
 *)

val o : ('b -> 'c) * ('a -> 'b) -> 'a -> 'c
val before : ('a * unit) -> 'a

val chr : int -> char
val ord : char -> int

val explode : string -> char list
val implode : char list -> string
val str     : char -> string
val concat  : string list -> string

val vector  : 'a list -> 'a vector

exception Option
val getOpt : 'a option * 'a -> 'a
val isSome : 'a option -> bool
val valOf  : 'a option -> 'a      

exception Empty;

val @       : 'a list * 'a list -> 'a list
val app     : ('a -> unit) -> 'a list -> unit
val foldl   : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
val foldr   : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
val hd      : 'a list -> 'a                     (* Empty     *)
val length  : 'a list -> int 
val map     : ('a -> 'b) -> 'a list -> 'b list
val null    : 'a list -> bool
val rev     : 'a list -> 'a list 
val tl      : 'a list -> 'a list                (* Empty     *)

val help    : string -> unit

(* [help str] provides on-line help on the topic indicated by str.  

   help "lib"   gives an overview of the Moscow ML library.
   help "U"     provides help on library unit U.

   Help uses a simple browser with the following commands, which must
   be followed by a newline:

      d	     move down by half a screen
      u      move up by half a screen
      t      move to top of file
      b      move to bottom of file
      /str   cyclically search for string str in help file (case-insensitive)
      n      search for next occurrence of str
      q      quit the browser

   A newline by itself moves down one screen (24 lines).
*)
