(* Miscoldb -- 1995-08-25.  Top-level compatility with the Definition *)

(* These functions really belong in General, but can appear there only 
   if defined in the runtime system.  So for now they are here.
 *)

val o : ('b -> 'c) * ('a -> 'b) -> 'a -> 'c
val before : ('a * unit) -> 'a

val chr : int -> string
val ord : string -> int

val explode : string -> string list
val implode : string list -> string
val str     : char -> string
val concat  : string list -> string

exception Empty;

val @          : 'a list * 'a list -> 'a list
val app        : ('a -> unit) -> 'a list -> unit
val foldl      : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
val foldr      : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
val hd         : 'a list -> 'a                    	(* Empty     *)
val length     : 'a list -> int 
val map        : ('a -> 'b) -> 'a list -> 'b list
val null       : 'a list -> bool
val rev        : 'a list -> 'a list 
val tl         : 'a list -> 'a list               	(* Empty     *)

val vector     : 'a list -> 'a vector

exception Abs  
      and Diff 
      and Exp  
      and Floor
      and Neg  
      and Prod 
      and Sum  
      and Mod  
      and Quot;
