(* Mosml -- some Moscow ML specific functions 1995-05-08 *)

val argv    : unit -> string list
val time    : ('a -> 'b) -> ('a -> 'b)
val listDir : string -> string list

(*
   [argv ()] returns the command line strings of the current process.
   Hence List.nth(commandLine, 0) is the command used to invoke the
   SML process, List.nth(commandLine, 1) is its first argument, and so
   on.  

   [time f arg] applies f to arg and returns the result; as a side
   effect, it prints the time (cpu, system, and real time) consumed by
   the evaluation.

   [listDir path] returns the list of all files and subdirectories of
   the directory indicated by path.  Raises OS.SysErr in case of failure.
*)

