(* NJ93 -- 1995-02-24 
   Half-way compatibility with those SML/NJ 0.93 basis structures
   which were open in the initial environment. 

   These functions are provided for compatibility, to help you make old
   programs work.

   Note that SML/NJ 0.93 `print' is overloaded at bool, int, real, and
   string, and that Moscow ML `print' is polymorphic but behaves
   differently from SML/NJ 0.93 print on string arguments.  The effect of
   SML/NJ 0.93 `print' for string type arguments can be achieved by:

   	BasicIO.say
*)

val print : string -> unit

(* NJ93 Integer *)

val max : int * int -> int
val min : int * int -> int

(* NJ93 List *)

exception Hd and Tl and Nth and NthTail

val hd      : 'a list -> 'a             (* Hd *)
val tl      : 'a list -> 'a list        (* Tl *)
val nth     : 'a list * int -> 'a       (* Nth *)
val nthtail : 'a list * int -> 'a list  (* NthTail *)
val app     : ('a -> 'b) -> 'a list -> unit
val revapp : ('a -> 'b) -> 'a list -> unit
val fold    : ('a * 'b -> 'b) -> 'a list -> 'b -> 'b
val revfold : ('a * 'b -> 'b) -> 'a list -> 'b -> 'b

(* NJ93 Real *)

val ceiling  : real -> int
val truncate : real -> int 

(* NJ93 Ref *)

val inc : int ref -> unit
val dec : int ref -> unit

(* NJ93 String *)

exception Substring;

val ordof     : string * int -> int
val ord       : string -> int                   (* Ord *)
val chr       : int -> string                   (* Chr *)
val substring : string * int * int -> string    (* Substring *)
val explode   : string -> string list
val implode   : string list -> string
