(* OS -- SML Standard Library *)

val osInfo : unit -> {
        archFamily : string,
        archName   : string,
        osName     : string,
        osVersion  : string
      }

type syserror

exception SysErr of string * syserror option

val errorMsg : syserror -> string

(*  Various functions for interacting with the operating system.

   [osInfo ()] returns a record describing the platform on which the
   program is running.  With Moscow ML, the field archFamily will
   always be "interp".  The field archName is a name for the actual
   (physical) processor type (e.g. "i486"), and the fields osName and
   osVersion contain the name and version of the operating system
   (e.g. "Linux" and "1.1.61").  

   [errorMsg err] returns a string explaining the error message system
   error code err, as found in a SysErr exception.  The precise form
   of the strings are operating system dependent.  
*)
