(* test/date.sml
   PS 1995-03-20, 1995-05-12
*)

use "auxil.sml";

local
    open Time Date 
    fun date h = 
	toString(fromTime(now() + realToTime (3600.0 * real h))) ^ "\n";
    fun nowdate () = Date.fromTime(now());
    fun say s = output(std_out, s);
    fun mkdate(y,mo,d,h,mi,s) =
	DATE {year=y, month=mo, day=d, hour=h, minute=mi, second=s, 
	      wday=SOME Fri, yday=SOME 5, isDst=NONE}
    fun cmp(dt1, dt2) = compare(mkdate dt1, mkdate dt2)
in
    
val _ = 
    (say "This is now:                    "; say (date 0);
     say "This is an hour from now:       "; say (date 1);
     say "This is a day from now:         "; say (date 24);
     say "This is a week from now:        "; say (date 168);
     say "This is 120 days from now:      "; say (date (24 * 120));
     say "This is 160 days from now:      "; say (date (24 * 160));
     say "This is 200 days from now:      "; say (date (24 * 200));
     say "This is 240 days from now:      "; say (date (24 * 240));
     say "This is the epoch (UTC):        "; 
     say (toString(fromUTC zeroTime) ^ "\n");   
     say "This is the number of the day:  "; 
     say (fmt "%j" (nowdate()) ^ "\n");
     say "This is today's weekday:        ";
     say (fmt "%A" (nowdate()) ^ "\n");
     say "This is the name of this month: ";
     say (fmt "%B" (nowdate()) ^ "\n"));

val test1 = 
check'(fn _ => 
               cmp((1993,Jul,25,16,12,18), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1995,May,25,16,12,18), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,May,26,16,12,18), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1994,Jul,24,16,12,18), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,Jun,24,17,12,18), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1994,Jun,26,15,12,18), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,Jun,25,15,13,18), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1994,Jun,25,17,11,18), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,Jun,25,16,11,19), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1994,Jun,25,16,13,17), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,Jun,25,16,12,17), (1994,Jun,25,16,12,18)) = LESS
       andalso cmp((1994,Jun,25,16,12,19), (1994,Jun,25,16,12,18)) = GREATER
       andalso cmp((1994,Jun,25,16,12,18), (1994,Jun,25,16,12,18)) = EQUAL);

val test2 = 
    check'(fn _ => 
	   fmt "%A" (mkdate(1995,May,22,4,0,1)) = "Monday");
end
