(* test/listpair.sml
   PS 1995-02-25
*)

use "auxil.sml";

local 
    open ListPair
    val a = [1, 2, 3, 4, 5, 6]
    val b = [1.0, 4.0, 5.0, 5.0]
    val ab = [(1, 1.0), (2, 4.0), (3, 5.0), (4, 5.0)]
    fun take 0 xs        = []
      | take n []        = []
      | take n (x :: xr) = x :: take (n-1) xr
in 

val test1 = check(zip([], []) = [] 
		  andalso zip ([], a) = [] 
		  andalso zip(a, []) = []
		  andalso zip(a, b) = ab
		  andalso zip(b, a) = List.map (fn (x,y) => (y,x)) ab);

val test2a = check(([], []) = unzip []
		   andalso (a, a) = unzip(zip(a,a))
		   andalso (take (length b) a, b) = unzip(zip(a, b))
		   andalso (b, take (length b) a) = unzip(zip(b, a)));
val test2b = check(ab = zip(unzip ab));

val test3a = check(map (fn (x, y) => real x + y) (a, b) = 
		  List.map (fn (x,y) => real x + y) (zip(a, b)));

local 
    val v = ref 0
    fun h [] r = r | h (x::xr) r = h xr (r+r+x): int;
    val isum = h (take (length b) a) 0
in 
    fun reset () = v := 0;
    fun incrv i = v := 2 * !v + i;
    fun checkv () = check(!v = isum);
end;

val test3b = (reset (); map (incrv o #1) (a, b) seq (); checkv());

val test4 = (reset (); app (incrv o #1) (a, b); checkv());

val test5a = check(all (fn _ => false) (a, [])
		   andalso not (exists (fn _ => true) ([], b))); 

val test5b = check(exists (fn (x, y) => x = 3) (a, b) 
		   andalso all (fn (x, y) => y <= 5.0) (a, b));

val test5c = check(not (exists (fn (x, y) => x = 5) (a, b))
		   andalso not (exists (fn (x, y) => y = 5) (b, a))
		   andalso all (fn (x, y) => x <> 6) (a, b)
		   andalso all (fn (x, y) => y <> 6) (b, a));

val test5d = (reset(); all (fn (x,y) => (incrv x; true)) (a, b) seq (); 
	      checkv());
val test5e = (reset(); exists (fn (x,y) => (incrv x; false)) (a, b) seq (); 
	      checkv());
end;

